<template>
    <section class="pad_def map-section">
        <div class="spinner spinner-hide"></div>
        <div class="mapCanvas">
            <div id="map"></div>
        </div>
    </section>
</template>

<script>

    module.exports = {
        data: function () {
            return {
                infowindow: [],
                markers: [],
                bounds: {},
                boundRequests: {},
                mapObj: {},
                mapName: 'map',
                rootObject: '',
                template:'',
                grayApartmentIcon: this.$parent.grayApartmentIcon,
                featuredApartmentIcon: this.$parent.featuredApartmentIcon,
                favoriteApartmentIcon: this.$parent.favoriteApartmentIcon,
                featuredHouseIcon: this.$parent.featuredHouseIcon,
                favoriteHouseIcon: this.$parent.favoriteHouseIcon,
                grayHouseIcon: this.$parent.grayHouseIcon,
                brokerPin: this.$parent.brokerPin,
                mapOptions: {
                    center: {},
                    scaleControl: !0,
                    panControl: !0,
                    mapTypeControl: !1,
                    streetViewControl: !1,
                    draggable: !0,
                    gestureHandling: 'greedy',
                },
                polyLinesBorders: [],
                show_safety_border: this.$parent.show_safety_border,
                mapBordersCount: this.$parent.mapBordersCount,
                mapBorders: this.$parent.mapBorders
            }
        },
        methods: {
            initMap() {
              var latlng = new google.maps.LatLng(this.$parent.cords.lat, this.$parent.cords.lng);

              if (this.$parent.school_Id == '250') {
                 latlng = new google.maps.LatLng(42.0989914, -75.9408849);

              }

              let mapOptions =
                  {
                    zoom: this.$parent.map_zoom,
                    gestureHandling: 'greedy',
                    center: latlng,
                    mapTypeId: 'roadmap',
                    suppressMarkers: true,

                  };
                this.mapObj = new google.maps.Map(document.getElementById(this.mapName), mapOptions);
                if (this.show_safety_border == 1 && this.mapBordersCount > 0) {
                    this.createSafetyBorders();
                }
                else{
                    if (this.$parent.school_Id == '5') {
                        const coords = [new google.maps.LatLng(43.04433496026252, -87.93386220932007), new google.maps.LatLng(43.04430359661551, -87.92999982833862), new google.maps.LatLng(43.04151216781186, -87.93006420135498), new google.maps.LatLng(43.04151216781186, -87.9257082939148), new google.maps.LatLng(43.04017913734059, -87.92575120925903), new google.maps.LatLng(43.04010072288151, -87.92025804519653), new google.maps.LatLng(43.0387519784997, -87.92025804519653), new google.maps.LatLng(43.038720611998535, -87.92176008224487), new google.maps.LatLng(43.037340470072834, -87.92178153991699), new google.maps.LatLng(43.03746593880338, -87.92334794998169), new google.maps.LatLng(43.03633671099268, -87.92742490768433), new google.maps.LatLng(43.036038716854996, -87.940514087677), new google.maps.LatLng(43.03741888805948, -87.9404067993164), new google.maps.LatLng(43.03740320447018, -87.94287443161011), new google.maps.LatLng(43.04016345445682, -87.94291734695435), new google.maps.LatLng(43.04016345445682, -87.94158697128296), new google.maps.LatLng(43.041465120170656, -87.94190883636475), new google.maps.LatLng(43.04148080272174, -87.93802499771118), new google.maps.LatLng(43.04292358027223, -87.93789625167847), new google.maps.LatLng(43.04297062679505, -87.93442010879517), new google.maps.LatLng(43.044429051107365, -87.93405532836914)];
                        this.createPolyline(coords);
                    }
                    else if (this.$parent.school_Id == '506') {
                        const coords = [
                            new google.maps.LatLng(38.956864, -92.320742), new google.maps.LatLng(38.956699, -92.320429), new google.maps.LatLng(38.956622, -92.3125592), new google.maps.LatLng(38.956617, -92.3123392), new google.maps.LatLng(38.956622, -92.312023), new google.maps.LatLng(38.956621, -92.312018),
                            new google.maps.LatLng(38.952334, -92.312139), new google.maps.LatLng(38.951899, -92.312129), new google.maps.LatLng(38.951156, -92.311934), new google.maps.LatLng(38.945573, -92.311273), new google.maps.LatLng(38.942879, -92.311875), new google.maps.LatLng(38.942961, -92.321968), new google.maps.LatLng(38.950479, -92.321913), new google.maps.LatLng(38.950574, -92.321974),
                            new google.maps.LatLng(38.951203, -92.321973), new google.maps.LatLng(38.951428, -92.321948), new google.maps.LatLng(38.951832, -92.321836), new google.maps.LatLng(38.952039, -92.321811), new google.maps.LatLng(38.952131, -92.321756), new google.maps.LatLng(38.953896, -92.321683), new google.maps.LatLng(38.956359, -92.321562),
                            new google.maps.LatLng(38.956631, -92.321548), new google.maps.LatLng(38.956558, -92.321226), new google.maps.LatLng(38.956685, -92.320968), new google.maps.LatLng(38.956864, -92.320742),
                        ];
                        this.createPolyline(coords);
                    }
                }
                this.campusMarker();
                this.listingMarkers();
            },
            campusMarker() {
                new google.maps.Marker({
                    position: this.$parent.cords,
                    map: this.mapObj,
                    alt:this.$parent.campusTitle,
                    icon: this.$parent.path + 'images/campus-marker.png'
                });
            },
            createPolyline(coords) {
                const i = {
                    path: "M 0,-1 0,1",
                    strokeOpacity: 1,
                    scale: 4,
                    strokeColor: "#00ADEE"
                };
                const s = new google.maps.Polyline({
                    path: coords,
                    strokeOpacity: 0,
                    icons: [{
                        icon: i,
                        offset: "0",
                        repeat: "20px"
                    }],
                    map: this.mapObj
                })
            },
            createSafetyBorders(){
                let mapObj = this.mapObj;
                let mapBorders = this.mapBorders;
                let routeBorderName = [];
                let drawPolyLine = this.polyLinesBorders;
                $.each(mapBorders, function(key, data){
                    routeBorderName[key] = $.parseJSON(data.coordinates);
                    drawPolyLine[key] = new google.maps.Polyline({
                        path: routeBorderName[key],
                        strokeOpacity: 0,
                        icons: [
                            {
                                icon: {
                                    path: "M 0,-1 0,1",
                                    strokeOpacity: 1,
                                    scale: 4,
                                    strokeColor: '#'+data.color //00ADEE
                                },
                                offset: '0',
                                repeat: '20px'//change this value to change the distance between arrows
                            }
                        ]
                    });
                    drawPolyLine[key].setMap(mapObj);
                });
            },
            calculateMinMax: function (min, max, type, listingData) {


                if (type == 'rent') {

                    if (min == null || max == null) {
                        return 'Ask'
                    }

                    if (max == false || min == false) {
                        if (min != false) {
                            return '$' +min;
                        } else if (max != false) {
                            return '$' +max;
                        }
                        return 'Ask'
                    } else if (min == max) {


                        if ((min == '0' && max == '0') || (min == 'Ask' && max == 'Ask')) {

                            return 'Ask';


                        } else {
                            if (max == false || min == false || min == 'Ask' || min == '0' || max == 'Ask') {
                                return 'Ask'
                            } else if (min == 'Ask' || min == '0') {
                                return '$' + max
                            }

                            return '$' + min


                        }


                    } else {
                        if ((min == '0' && max == '0') || (min == 'Ask' && max == 'Ask')) {


                            return 'Ask'


                        }
                        if (max == false || min == false || max == 'Ask' || min == 'Ask') {
                            return 'Ask'
                        }
                        if (min == 'Ask' || min == '0') {
                            return '$' + max
                        }

                        if (max == 'Ask' || max == '0') {
                            return '$' + min
                        }
                        return '$' + min + ' - $' + max


                    }


                }
                else if (type == 'unit_rent') {

                    if (max == false || min == false) {
                        return 'Ask'
                    } else if (min == max) {


                        if ((min == '0' && max == '0') || (min == 'Ask' && max == 'Ask')) {


                            return 'Ask'


                        } else {

                            if (max == false || min == false) {
                                return 'Ask'
                            } else if (min == 'Ask' || min == '0') {
                                return '$' + max
                            }

                            return '$' + min


                        }


                    } else {
                        if ((min == '0' && max == '0') || (min == 'Ask' && max == 'Ask')) {


                            return 'Ask'


                        }
                        if (max == false || min == false) {
                            return 'Ask'
                        }

                        if (min == 'Ask' || min == '0') {
                            return '$' + max
                        }

                        if (max == 'Ask' || max == '0') {
                            return '$' + min
                        }

                        return '$' + min + ' - $' + max


                    }


                }
                else if (type == 'bedrooms') {


                    if (min == max) {


                        if (min == '0') {


                            return 'Studio'


                        } else {


                            return (typeof min == 'undefined' || min == '')  ? 'S Bed' : min + ' Bed'


                        }


                    } else {


                        return ((min == '0' || min == 'undefined' || min == '') ? 'S' : min) + ' - ' + max + ' Bed'


                    }


                }
                else if (type == 'bathrooms') {


                    if (min == max) {


                        return min + ' Bath'


                    } else {


                        return min + ' - ' + max + ' Bath'


                    }


                }
                else if (type == 'sq_footage') {


                    if (min == max) {


                        if (min == '-') {


                            return !1


                        } else {


                            return min + ' sqft'


                        }


                    } else {


                        return min + ' - ' + max + ' sqft'


                    }


                }


            },
            listingMarkers() {
                //this.markers.forEach(a => a.setMap(null));
                for (var m in this.markers) {
                 this.markers[m][0].setMap(null)
                }
                this.markers = [];
                let parentObj = this;
                let rootObj = this.rootObject;
                let mapObj = this.mapObj;
                let listData = this.$parent.listData;
                setTimeout(()=>{
                    rootObj = this.$root.$refs.listView
                },500)
                parentObj.$root.favCount = 0;
              let subUsers = this.$parent.bannner_users;
                for (const i in listData) {
                    const listingData = listData[i];

                   /*  
                        if(listingData.landlord_id != parentObj.$root.landlordFilterID){
                            continue;
                        }
                     */
                 if(parentObj.$root.landlordFilterID != 0){
                    if (subUsers.indexOf(listingData.landlord_id.toString()) == -1 ) {
                            continue;
                        }
                   }
                    /*Check Fav*/
                    const cookieName = 'rcp_id[' + listingData.id + ']';
                    var cookieVal = parentObj.readCookie(cookieName);
                    if (cookieVal == listingData.id) {
                        parentObj.$root.favCount++;
                    }

                    /*Check Fav*/
                    let icon = parentObj.listingIcon(listingData);
                    const mark = new google.maps.Marker({
                        position: new google.maps.LatLng(listingData.lat, listingData.lng),
                        map: mapObj,
                        title: listingData.title,
                        icon: icon,
                        visible: !0
                    });
                    if (!parentObj.markers[listingData.id]) {
                        parentObj.markers[listingData.id] = [];
                    }

                    parentObj.markers[listingData.id].push(mark);

                    const title = listingData.title == ''?listingData.street_address_short:listingData.title;
                    const bed = parentObj.calculateMinMax(listingData.min_bed,listingData.max_bed,'bedrooms',listingData);
                    const rent = parentObj.calculateMinMax(listingData.min_rent,listingData.max_rent,'rent',listingData);
                    let mapFeaturedImage = "https://s3.amazonaws.com/rcp-prod-uploads/property_images/slider_images/" + listingData.featured_image;
                    if (parentObj.$root.isSafari && typeof listingData.original_name[0] != 'undefined') {
                        mapFeaturedImage = "https://s3.amazonaws.com/rcp-prod-uploads/property_images/slider_images/" + listingData.original_name[0];
                    }
                    parentObj.template = `<div class="iw-unselectable">
                                           <div class="iw-title">`+title+`</div>
                                           <div class="iw-content">
                                               <img style="width: 330px;height: 200px;" alt="`+title+`" data-src="https://s3.amazonaws.com/rcp-prod-uploads/property_images/slider_images/`+listingData.featured_image+`">
                                           </div>
                                            <div class="iw-bottom-gradient">
                                           <p><i class="bg-bed sprite mr-1"> </i>`+bed+` </p><span>`+rent+`</span>
                                           </div>
                                           </div>`;

                    parentObj.infowindow[listingData.id] = new google.maps.InfoWindow({


                        content: '',
                        /*content: parentObj.template,*/


                        disableAutoPan: !0,


                        // pixelOffset: new google.maps.Size(posi.left, posi.top),
                        pixelOffset: new google.maps.Size(0, -60),

                        zIndex: null,


                        boxStyle: {

                            background: "",

                            opacity: 0.99

                        },


                        closeBoxMargin: "0px",


                        closeBoxURL: "",


                        infoBoxClearance: new google.maps.Size(1, 1),


                        isHidden: !1,


                        pane: "floatPane",


                        enableEventPropagation: !0


                    });
                    //parentObj.infowindow[listingData.id].content.replace('data-src','src');
                    parentObj.markers[listingData.id][0].addListener('mouseover', function() {
                        //parentObj.infowindow[listingData.id].content.replace('/data-src/gi','src');
                        parentObj.template = `<div class="iw-unselectable">
                                           <div class="iw-title">`+title+`</div>
                                           <div class="iw-content">
                                               <img style="width: 330px;height: 200px;" alt="`+title+`" src="`+mapFeaturedImage+`">
                                           </div>
                                            <div class="iw-bottom-gradient">
                                           <p><i class="bg-bed sprite mr-1"> </i>`+bed+` </p><span>`+rent+`</span>
                                           </div>
                                           </div>`;
                        parentObj.infowindow[listingData.id].setContent(parentObj.template);
                        parentObj.infowindow[listingData.id].open(mapObj, parentObj.markers[listingData.id][0]);
                    });
                    parentObj.markers[listingData.id][0].addListener('mouseout', function() {
                        parentObj.infowindow[listingData.id].close();
                    });
                    parentObj.markers[listingData.id][0].addListener('click', function() {

                        parentObj.$root.hoveredMarkers.push(listingData.id);

                        dataLayer.push({
                            'event': 'campusMap_listingClick',
                            'category': 'Leads',
                            'action': 'Listing',
                            'label': 'Campus Map'
                        });
                        if (typeof listingData.units_number !== 'undefined' && listingData.units_number >= 25) {
                            parentObj.markers[listingData.id][0].setIcon(parentObj.grayApartmentIcon);
                        } else {
                            parentObj.markers[listingData.id][0].setIcon(parentObj.grayHouseIcon);
                        }

                        parentObj.$root.$refs.listView.openDetailModal(listingData,'map')
                    });

                }

            },

            listingIconOld(listingData) {
                let icon = '';
                if(this.$parent.hoveredMarkers.indexOf(listingData.pid) == -1) {
                    if (typeof listingData.units_number !== 'null' && listingData.units_number >= 25) {
                        icon = listingData.is_broker ? this.brokerPin : this.featuredApartmentIcon;
                    } else {
                        icon = listingData.is_broker ? this.brokerPin : this.featuredHouseIcon;
                    }
                }else{
                    if (typeof listingData.units_number !== 'undefined' && listingData.units_number >= 25) {
                        icon = listingData.is_broker ? this.brokerPin : this.grayApartmentIcon;
                    } else {
                        icon = listingData.is_broker ? this.brokerPin : this.grayHouseIcon;
                    }
                }
                return icon;
            },
            listingIcon(listingData) {
                let icon = '';
                if(this.$parent.hoveredMarkers.indexOf(listingData.pid) == -1) {
                    if (listingData.category_id == 15) {
                        icon = listingData.is_broker ? this.brokerPin : this.featuredApartmentIcon;
                    } else {
                        icon = listingData.is_broker ? this.brokerPin : this.featuredHouseIcon;
                    }
                }else{
                    if (listingData.category_id == 15) {
                        icon = listingData.is_broker ? this.brokerPin : this.grayApartmentIcon;
                    } else {
                        icon = listingData.is_broker ? this.brokerPin : this.grayHouseIcon;
                    }
                }
                return icon;
            },
            readCookie: function (name) {


                var i, c, ca, nameEQ = name + "=";


                ca = document.cookie.split(';');


                for (i = 0; i < ca.length; i++) {


                    c = ca[i];


                    while (c.charAt(0) == ' ') {


                        c = c.substring(1, c.length)


                    }


                    if (c.indexOf(nameEQ) == 0) {


                        return c.substring(nameEQ.length, c.length)


                    }


                }


                return ''


            },
            boundsChanged() {
                const Map = this.mapObj;
                const Obj = this;
                let timeOut = null;
                let it = 0;
                Map.addListener('bounds_changed', function () {
                    it++;
                    if(it == 1) {
                        return false;
                    }
                    const mapBounds = Map.getBounds();
                    const southWest = mapBounds.getSouthWest();
                    const northEast = mapBounds.getNorthEast();
                    const minLat = southWest.lat();
                    const maxLat = northEast.lat();
                    const minLon = southWest.lng();
                    const maxLon = northEast.lng();
                    Obj.bounds = {
                        minLat: minLat,
                        maxLat: maxLat,
                        minLon: minLon,
                        maxLon: maxLon
                    }
                    clearTimeout(timeOut);
                    timeOut = setTimeout(function () {
                        Obj.reloadMap();
                    }, 200);
                });


            },
            filterListing() {
                const data = this.$parent.allListingData;
                const bounds = this.bounds;
                const minLat = this.intToFloat(bounds.minLat, 6);
                const maxLat = this.intToFloat(bounds.maxLat, 6);
                const minLon = this.intToFloat(bounds.minLon, 6);
                const maxLon = this.intToFloat(bounds.maxLon, 6);
                const filteredListings = [];
                for (const i in data) {
                    if ((parseFloat(data[i].lat) >= parseFloat(minLat) && parseFloat(data[i].lat) <= parseFloat(maxLat)
                        && parseFloat(data[i].lng) >= parseFloat(minLon) && parseFloat(data[i].lng) <= parseFloat(maxLon))
                    ) {
                        filteredListings.push(data[i]);
                    }

                }
              this.$parent.$refs.filterView.mapFilteredData(filteredListings);
                //this.$parent.resetListingData(filteredListings);
            },
            reloadMap() {
                this.filterListing()
            },
            intToFloat(num, decPlaces) {
                return parseFloat(num).toFixed(decPlaces)
            },
            shrinkListing(listings) {
                const latLng = [];
                for (const i in listings) {
                    const data = listings[i];
                    const cords = new google.maps.LatLng(data.lat, data.lng);
                    latLng.push(cords)
                }
                //$parent.listData = listings;

                const c = new google.maps.LatLngBounds;


                for (const i in latLng) {


                    const cords = latLng[i];


                    c.extend(cords)


                }


                //this.mapObj.fitBounds(c)
            }
        },
        mounted: function () {
            this.initMap();
            this.boundsChanged()


        },
        updated: function () {

            this.ignoreChangeBoundsEvent = false;
        }

    }
</script>